/*
** pork_imwindow.h - interface for manipulating conversation/chat/info windows.
** Copyright (C) 2002 Ryan McCabe <ryan@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#ifndef __PORK_IMWINDOW_H
#define __PORK_IMWINDOW_H

#define IMWINDOW(x)	((struct imwindow *) (x))

#define TYPE_STATUS		0
#define TYPE_IM			1
#define TYPE_CHAT		2

#define FOCUS_MSG		0
#define FOCUS_BUDDY		1

struct imwindow {
	struct swindow swindow;
	struct input *input;
	struct aim_priv *priv;
	struct key_binds *active_binds;
	char *target;
	char *name;
	u_int32_t refnum;
	u_int32_t typing:2;
	u_int32_t blist_visible:1;
	u_int32_t input_focus:1;
	u_int32_t type:2;
	struct window_opts opts[WOPT_NUM_OPTS];
};

struct imwindow *imwindow_new(	u_int32_t rows,
								u_int32_t cols,
								u_int32_t refnum,
								u_int32_t type,
								struct aim_priv *priv,
								char *target);

void imwindow_resize(	struct imwindow *imwindow,
						u_int32_t rows,
						u_int32_t cols);

void imwindow_recv_im(struct imwindow *win, const char *src, const char *msg);
inline void imwindow_rename(struct imwindow *imwindow, char *new_name);
int imwindow_refresh_blist(struct imwindow *imwindow);
void imwindow_refresh(struct imwindow *imwindow);
void imwindow_destroy(struct imwindow *imwindow);
void imwindow_switch_focus(struct imwindow *imwindow);
struct imwindow *imwindow_find(const char *target);
int imwindow_bind_acct(struct imwindow *imwindow, char *user);
void imwindow_send_im(struct imwindow *imwindow, char *str);

#endif
